
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>在不清楚数据表字段数据分布的情况下，应该创建什么类型的索引？ / 憋错料</title>

    <meta name="description" content="在不清楚数据表字段数据分布的情况下，应该创建什么类型的索引？ 在讨论之前,先看看关系型数据库常见的索引类型: 1.位图索引,适用于该字段重复数据很多的情况: 2.B+树索引,适用于该字段重复数据不多的情况. 在不清楚数据表字段数据分布的情况下,应该创建什么类型的索引?个人觉得以上两种都不太适用,可以尝试使用第3类的索引: 3.倒排索引,在搜索引擎使用较多,适用于大多数的情况. 使用普通的文本文件格式存储倒排索引,格式为: value:rowid(行标识码),字段值对应value,rowid对应该行的标识码. 要注意的是,在创建倒排索引时,倒排索引的key需">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">在不清楚数据表字段数据分布的情况下，应该创建什么类型的索引？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在讨论之前，先看看关系型数据库常见的索引类型：</p>
<p>1.位图索引，适用于该字段重复数据很多的情况；</p>
<p>2.B+树索引，适用于该字段重复数据不多的情况。</p>
<p>在不清楚数据表字段数据分布的情况下，应该创建什么类型的索引？个人觉得以上两种都不太适用，可以尝试使用第3类的索引：</p>
<p>3.倒排索引，在搜索引擎使用较多，适用于大多数的情况。</p>
<p>使用普通的文本文件格式存储倒排索引，格式为：</p>
<p>value:rowid(行标识码)，字段值对应value，rowid对应该行的标识码。</p>
<p>要注意的是，在创建倒排索引时，倒排索引的key需要按ascii码排序。</p>
<p>同时，为了加快搜索的速度，为倒排索引创建索引的元数据，包括：</p>
<p>1.倒排索引文件的最大值和最小值。</p>
<p>2.倒排索引文件索引。</p>
<p>样例元数据如下：</p>
<p>[data]</p>
<p>min:1(该字段最小值)</p>
<p>max:100(该字段最大值)</p>
<p>[index]</p>
<p>1:value,offset(索引文件第1行的字段值和索引文件的偏移量)</p>
<p>10000:value,offset(索引文件第10000行的字段值和索引文件的偏移量)</p>
<p>......</p>
<p>n:value,offset(索引文件第n行的字段值和索引文件的偏移量)</p>
<p>在实际查询时，给出查询条件，通过读取索引的元数据可以很快的定位到该查询条件对应的倒排索引，再通过倒排索引查询数据。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 09:27:35 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>在不清楚数据表字段数据分布的情况下，应该创建什么类型的索引？的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/385nbR4.html" rel="bookmark">tp数据表字段缓存</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在维护一个tp写的项目,因为需要在产品表product中增加了一个字段status,但是不论如何就是无法给status赋值,查了资料才发现,原来是tp的数据表字段缓存在搞鬼. 在runtime&gt;Data&gt;_fields文件中找到对应的文件,文件名与表名同,这里是Product.php,增加status.再次尝试,立马就可以了. 在网上看到一篇讲这个问题的文章如下, 今天在应用thinkphp框架开发的程序做些二次开发修改, 其中有改动到数据结构,新增了几个字段. 调用 M(‘xxx’)-&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02W1Wa3.html" rel="bookmark">MySQL数据表字段内容的批量修改、复制命令</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制字段里的数据命令: SQL代码 UPDATE table SET 被替换的字段名=被复制的字段名 演示如下 SQL代码 UPDATE dede_archives SET senddate=pubdate 如何手动将同一数据表内不同字段之间的内容批量转换,可以参考下面的命令: SQL代码 UPDATE table set 字段名=REPLACE(字段名,'原字符串','替换的字符串') where 已知的字段名 LIKE '%原字符串%' 应用到本文实例 SQL代码 UPDATE pw_mem			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MW8dDb0.html" rel="bookmark">tp5&period;0  SHOW COLUMNS FROM 生成数据表字段缓存</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				TP5.0 生成数据表字段缓存 =控制台执行以下命令= 1.生成指定数据库的所有表字段缓存 php think optimize:schema --db databaseName 2.生成指定数据表的缓存 php think optimize:schema --table tableName 3.应用使用了不同的数据库连接,可以根据模块来生成,如下: php think optimize:schema --module index 生成之后关闭调试模式:就不会执行 SHOW COLUMNS FR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47Bqgx3.html" rel="bookmark">Mysql数据表字段的增，改，删</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用 alter 命令来进行字段的增,改,删 1.使用 ALTER 命令及 DROP 子句来删除以上创建表的 i 字段:(如果数据表中只剩余一个字段则无法使用DROP来删除字段.) mysql&gt; alter table runoob drop name; //删除runoob表中的name字段 2.使用 ALTER 命令 ADD 子句来向数据表中添加列,如下实例在表 testalter_tbl 中添加 i 字段,并定义数据类型: mysql&gt; alter table runoob add id			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wLgeZ4.html" rel="bookmark">es 在数据量很大的情况下（数十亿级别）如何提高查询效率啊？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面试题es 在数据量很大的情况下(数十亿级别)如何提高查询效率啊?面试官心理分析这个问题是肯定要问的,说白了,就是看你有没有实际干过 es,因为啥?其实 es 性能并没有你想象中那么好的.很多时候数据量大了,特别是有几亿条数据的时候,可能你会懵逼的发现,跑个搜索怎么一下 5~10s,坑爹了.第一次搜索的时候,是 5~10s,后面反而就快了,可能就几百毫秒.你就很懵,每个用户第一次访问都会比较慢,比较卡么?所以你要是没玩儿过 es,或者就是自己玩玩儿 demo,被问到这个问题容易懵逼,显示出你对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xjrVQ4.html" rel="bookmark">laravel 同数据表字段比较查询和状态不正规排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天写群组推荐接口,要求未满的群 ( 群最大人数字段maxusers, 群人数字段affiliations_count 都在群组表中),官方,热门(普通群0 ,官方1,热门2 ) 排序的群 同表字段比较查询: -&gt;whereRaw('affiliations_count  &lt; maxusers') 按规定的状态排序(本例中要按1,2,0排序) -&gt;orderByRaw(&quot;FIELD(group_level, &quot; . implode(&quot;, &quot;, [1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmNPxQ0.html" rel="bookmark">Hibernate实体类与数据表字段默认值之间的优先关系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在日常的应用开发过程中,我们一般都会使用对象关系映射来通过面向对象的编程模型来解决数据库的操作,我们生产过程当中使用较多的当属Hibernate框架了,他非常灵活,为我们提供了多种方式来实现数据层的操作与管理.通过实体类与数据表的映射,实体类对应表,属性对应字段就可以将我们想要生产的对象赋值到数据库,但是我们有时也需要查询对象,但是无论什么操作,都必须通过实体类来传递数据. 有时我们数据库有一些字段是数据库自动赋值,禁止用户通过程序修改的,如记录生成时间,那么如果你实体类按照正常情况下,你为了查			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lG7rpM.html" rel="bookmark">phome&lowbar;enewsclass 数据表字段解释（栏目主表）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				字段名 类型 解释 附加说明 classid smallint(6) 栏目ID   bclassid smallint(6) 父栏目ID   classname varchar(50) 栏目名称   sonclass text 终极栏目ID集合 父栏目下所有终极栏目ID集合,多个栏目ID用“|”隔开,例如:|1|5|8| is_zt tinyint(1)   预定义字段,暂时用不到,默认值0 lencord smallint(6) 每页显示信息数   link_num tinyint(4) 相关			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/418Dgk3.html" rel="bookmark">phome&lowbar;ecms&lowbar;news 数据表字段解释（新闻系统模型－主表）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.phome.net/doc/manual/extend/html/dbdoc/index.html 字段名 类型 解释 附加说明 id int(11) 信息ID   classid smallint(6) 栏目ID   onclick int(11) 点击数   newspath char(20) 存放日期目录   keyboard char(160) 关键字   keyid char(255) 相关链接信息ID集合 多个信息ID用半角逗号“,”隔开 userid int(			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPN1Bv3.html" rel="bookmark" class="title">（转载）nohup命令让Linux程序永远在后台执行</a>
					<div>
						Unix/Linux下一般想让某个程序在后台运行,很多都是使用 &amp; 在程序结尾来让程序自动运行.我们自己编写的程序只是普通程序,一般这种程序即使使用 &amp; 结尾,如果终端关闭,那么程序也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJVwV4.html" rel="bookmark" class="title">前端编程提高之旅（二）----网站常见特效的jquery实现</a>
					<div>
						最好的编程语言是逻辑,前端各种交互特效的实现多可以用jquery实现,特效可以纷飞,内在逻辑则基本不变.这一篇文章主要介绍jquery实现常见特效背后的逻辑.    1.通过类名获取元素集合    首 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZDL7LM.html" rel="bookmark" class="title">1-1 Varnsih 缓存服务</a>
					<div>
						1.varnish系统架构 varnish主要运行两个进程:Management进程和Child进程(也叫Cache进程). Management进程主要实现应用新的配置.编译VCL.监控varnis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d926w3.html" rel="bookmark" class="title">费曼致学生真野光一</a>
					<div>
						这是理查德·费曼回复学生真野光一的一封信,附英文原版. 费曼致学生真野光一(Koichi Mano) 真野是获诺贝尔奖的科学家费曼从前的学生,也曾经是朝永振一郎的学生.他写信来道贺.费曼回了信,问他近 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/382NxnM.html" rel="bookmark" class="title">防范逆向工程的方式</a>
					<div>
						代码混淆,降低代码可读性:eg:Proguard 将敏感数据和操作放到服务端进行: 迭代散列与使用盐值,降低hash碰撞,降低暴力破解hash的可能性 选择合适位置存储敏感信息,SQLite,pref ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qwp5B0.html" rel="bookmark" class="title">精品软件 推荐  虚拟光驱工具 DAEMON Tools</a>
					<div>
						给大家分享一款虚拟光驱工具.DAEMON Tools PRO Advanced 6.0 破解版-光学媒体模拟的最佳软件. 所有 DAEMON Tools的功能现在都在 一个解决方案里面.DAEMON  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNyv64.html" rel="bookmark" class="title">【翻译自mos文章】计算Oracle数据库中两个日期之间的工作日天数</a>
					<div>
						计算两个日期之间的工作日天数(不包括这两个日期,不包括weekend) 参考自: How to Compute Business Days for a Date Range in SQL or PLS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/382GQ2M.html" rel="bookmark" class="title">HDU 5139</a>
					<div>
						题目意思是f(n)=1!*2!*...*n! 求f(n); 如果直接开个10^7大的数组,会直接超内存 而时间是2s,所以用时间换内存 就开了两个10^6的数组,n[i]表示(i*10)!,f[i]表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5aey3.html" rel="bookmark" class="title">Java中的内存泄露</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekNzp4.html" rel="bookmark" class="title">AngularJS：如何使用自定义指令来取代ng-repeat</a>
					<div>
						引言 本文主要介绍了另一种即具有与ng-repeat 一样处理大量数据的绑定的功能,又具有超高的性能. 对于处理小数量,ng-repeat是非常有用的,但是如果需要处理非常大的数量集,还是采用自定义的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nLgLv4.html" rel="bookmark" class="title">linux下 mysql数据库的备份和还原sql</a>
					<div>
						1.备份 1 [[email protected] ~]# mysqldump -u root -p mysql &gt; ~/mysql.sql #把数据库mysql备份到家目录下命名为mysql. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqWna0.html" rel="bookmark" class="title">bzoj3637 CodeChef  SPOJ - QTREE6 Query on a tree VI 题解</a>
					<div>
						题意: 一棵n个节点的树,节点有黑白两种颜色,初始均为白色.两种操作:1.更改一个节点的颜色;2.询问一个节点所处的颜色相同的联通块的大小. 思路: 1.每个节点记录仅考虑其子树时,假设其为黑色时所处 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0azkyk3.html" rel="bookmark" class="title">linux 段错误常见处理方法</a>
					<div>
						1.如果没有产生core文件,可以查询系统log 通过 sudo cat /var/log/messages |grep segfault 或者 sudo dmesg|grep segfault 获得 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNWpW4.html" rel="bookmark" class="title">Logback LogBack</a>
					<div>
						1.简介 LogBack是一个日志框架,它与Log4j可以说是同出一源,都出自Ceki Gülcü之手.(log4j的原型是早前由Ceki Gülcü贡献给Apache基金会的) 1.1 LogBac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWrEWk4.html" rel="bookmark" class="title">android  银联支付接入报nullexception异常</a>
					<div>
						package com.example.ex_example; import java.io.ByteArrayOutputStream; import java.io.InputStream; im ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBJln4.html" rel="bookmark" class="title">云端 Linux下安装 Java</a>
					<div>
						根据需要在给云端的机器安装Java 问题的分解为2个一个是Java源文件的传输.一个是Linux下Java的安装. Java 传输到云端: 可以通过SSH Secure File Transfer C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPxl1M.html" rel="bookmark" class="title">最简js深浅拷贝说明</a>
					<div>
						1.浅拷贝 浅拷贝是拷贝引用,拷贝后的引用都是指向同一个对象的实例,彼此之间的操作会互相影响.  浅拷贝分两种情况: 1.直接拷贝源对象的引用 2. 源对象拷贝实例,但其属性对象(类型为Object, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBj9xEM.html" rel="bookmark" class="title">浅谈Struts2&lpar;二&rpar;</a>
					<div>
						一.struts2的跳转 1.action跳转JSP a.默认为forward &lt;action name=&quot;action1&quot; class=&quot;com.liquidxu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmQ6AnM.html" rel="bookmark" class="title">【转载】Unity3D研究院之与根据动态的两个轨迹点绘制面详解</a>
					<div>
						大家应该知道3D世界中任何的面都是由三角形绘制完成的,因为任何无规则的集合图形都可以由三角形来组成.比如四边形,无论是正四边形还是无规则四边形都可以由两个三角形拼接而成.结合本文的标题大家仔细想想,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzXexO3.html" rel="bookmark" class="title">binlog2sql 实战心得</a>
					<div>
						原创:binlog2sql在GitHub的地址:https://github.com/danfengcao/binlog2sql 作者:danfengcao 功能:从MySQL binlog解析出你要 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
